UpdateDistributionConfiguration - EC2 Image Builder
Services or capabilities described in AWS documentation might vary by Region. To see the differences applicable to the AWS European Sovereign Cloud Region, see the AWS European Sovereign Cloud User Guide.

UpdateDistributionConfiguration

Updates a distribution configuration. Distribution configurations define and configure the outputs for your images, including the target Regions, accounts, and settings for each Region.

Note

This operation doesn't support selective updates. The request replaces the stored configuration, so include every setting that you want to keep.

Request Syntax

PUT /UpdateDistributionConfiguration HTTP/1.1 Content-type: application/json { "clientToken": "string", "description": "string", "distributionConfigurationArn": "string", "distributions": [ { "amiDistributionConfiguration": { "amiTags": { "string" : "string" }, "description": "string", "kmsKeyId": "string", "launchPermission": { "organizationalUnitArns": [ "string" ], "organizationArns": [ "string" ], "userGroups": [ "string" ], "userIds": [ "string" ] }, "name": "string", "targetAccountIds": [ "string" ] }, "containerDistributionConfiguration": { "containerTags": [ "string" ], "description": "string", "targetRepository": { "repositoryName": "string", "service": "string" } }, "fastLaunchConfigurations": [ { "accountId": "string", "enabled": boolean, "launchTemplate": { "launchTemplateId": "string", "launchTemplateName": "string", "launchTemplateVersion": "string" }, "maxParallelLaunches": number, "snapshotConfiguration": { "targetResourceCount": number } } ], "launchTemplateConfigurations": [ { "accountId": "string", "launchTemplateId": "string", "setDefaultVersion": boolean } ], "licenseConfigurationArns": [ "string" ], "region": "string", "s3ExportConfiguration": { "diskImageFormat": "string", "roleName": "string", "s3Bucket": "string", "s3Prefix": "string" }, "ssmParameterConfigurations": [ { "amiAccountId": "string", "dataType": "string", "parameterName": "string" } ] } ] }

URI Request Parameters

The request does not use any URI parameters.

Request Body

The request accepts the following data in JSON format.

clientToken

A unique, case-sensitive identifier you provide to ensure that the operation runs no more than one time. If you retry a request with the same client token, Image Builder returns the original response without running the operation again. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

Required: Yes

description

The description of the distribution configuration.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1024.

Required: No

distributionConfigurationArn

The Amazon Resource Name (ARN) of the distribution configuration that you want to update.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):distribution-configuration/[a-z0-9-_]+$

Required: Yes

distributions

The distribution settings for the configuration. Each entry defines how output images are distributed in one target AWS Region. A Region can appear at most once in the list. This list replaces the configuration's existing distributions entirely.

Type: Array of Distribution objects

Required: Yes

Response Syntax

HTTP/1.1 200 Content-type: application/json { "clientToken": "string", "distributionConfigurationArn": "string", "requestId": "string" }

Response Elements

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

clientToken

The client token that uniquely identifies the request.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

distributionConfigurationArn

The Amazon Resource Name (ARN) of the distribution configuration that was updated by this request.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):distribution-configuration/[a-z0-9-_]+$

requestId

The request ID that uniquely identifies this request.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1024.

Errors

For information about the errors that are common to all actions, see Common Error Types.

CallRateLimitExceededException

You have exceeded the permitted request rate for the Amazon EC2 APIs that Image Builder calls on your behalf. Retry with an increasing or variable delay between requests.

HTTP Status Code: 429

ClientException

A generic client error. This error usually indicates that the request failed a validation check, such as when a downstream service rejects a configured value.

HTTP Status Code: 400

ForbiddenException

You are not authorized to perform the requested operation.

HTTP Status Code: 403

IdempotentParameterMismatchException

You have specified a client token for an operation using parameter values that differ from a previous request that used the same client token.

HTTP Status Code: 400

InvalidParameterCombinationException

You have specified a combination of parameters that isn't valid. For example, two mutually exclusive parameters, or a parameter without its required companion parameter. Review the error message for details.

HTTP Status Code: 400

InvalidRequestException

The request is malformed or otherwise invalid. Verify the request and try again.

HTTP Status Code: 400

ResourceInUseException

The resource that you are trying to operate on is currently in use. Review the message details and retry later.

HTTP Status Code: 400

ServiceException

An internal server error occurred while Image Builder processed the request. Retrying the request may succeed.

HTTP Status Code: 500

ServiceUnavailableException

The service is unable to process your request at this time.

HTTP Status Code: 503

Examples

Update a distribution configuration

The following example replaces the distribution settings for the specified configuration with a single distribution that names the output AMI with the build date.

Sample Request

PUT /UpdateDistributionConfiguration HTTP/1.1 Content-type: application/json { "distributionConfigurationArn": "arn:aws:imagebuilder:us-west-2:111122223333:distribution-configuration/my-example-distribution", "distributions": [ { "region": "us-west-2", "amiDistributionConfiguration": { "name": "my-example-image-{{ imagebuilder:buildDate }}" } } ], "clientToken": "a1b2c3d4-5678-90ab-cdef-EXAMPLEccccc" }

Sample Response

HTTP/1.1 200 Content-type: application/json { "requestId": "97d5c3e8-93d6-424c-90e0-bab18b20bf54", "distributionConfigurationArn": "arn:aws:imagebuilder:us-west-2:111122223333:distribution-configuration/my-example-distribution" }

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: